Editorial for Wesley's Anger Contest 4 Problem 3 - Squirrel Tag
Submitting an official solution before solving the problem yourself is a bannable offence.
Author:
First of all, note that since Michael moves faster than all of the squirrels, a solution is guaranteed to exist (and hence some optimal solution exists).
Subtask 1
In this subtask, all squirrels remain on the x-axis during the game of tag. The "intended" greedy solution involves trying to catch all the squirrels to the left of the origin before all the squirrels to the right, and vice versa, but sadly I cannot prove its correctness (with the exception of proof by AC).
Time Complexity:
Remark: For the next two subtasks, note that any optimal solution will involve catching the
Now let's convince ourselves that an optimal solution is always found if Michael catches each squirrel as quickly as possible before the next squirrel in this order. Let an optimal solution be such that Michael catches the squirrels in the order
Subtask 2
For subtask 2, with constraints
Time Complexity:
Subtask 3
Subtask 3 was simply the improvement from factorial to exponential time, the well-known travelling salesman problem. The most popular solution is to represent each state as a pair of the most recently tagged squirrel and a bitmask representing which squirrels have been previously tagged. Constraints were made to permit binary search to pass (since this isn't a math competition, after all).
Time Complexity:
[1] Note that
Comments
Hey can you share the math thing, How we can find the time directly Like I am using binary search over real numbers for around 200 iterations but still getting the wrong answer!!